#! /bin/csh -f

# Use this script in conjunction with the disks.c file (after you compile it of course)
# incomp.sh is an example script that you should run from cron (preferably right midnight)
# Example of cron entry: 05 00 * * * /glftpd/bin/incomp.sh
# (this runs 5 minutes after midnigt)

# START SETUP #

# disks_path is the path to the disks binary
set disks_path = "/glftpd/bin/disks"

# END SETUP #

if ( $#argv != 1 ) then
  echo Syntax: "$0 <dated-dir or Utils/Games dir>"
  echo IE: "$0 /glftpd/site/incoming/0703"
  exit(1)
endif

if (! -d $1 ) then
	echo $1 does not exist or is not a directory!
	exit(1)
endif

cd $1
foreach x ( * )
  if ( -d "$x" ) then
	cd "$x"
	set zipcount = `ls *.zip | wc -w`
	set dizcount = `$disks_path`
	@ difference = $zipcount - $dizcount
	if ($difference != 0) then
		if ($dizcount == 0) then
			set dizcount = "UNKNOWN"
		else if ($dizcount == -1) then
			set dizcount = "NODIZ"
		endif
		echo "$x" : $zipcount of $dizcount
	endif
	cd ..
  else
	echo "$x" is not a directory
  endif
end

